Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javacard.security
Class MessageDigest

    java.lang.Object
      javacard.security.MessageDigest

Direct Known Subclasses:
  MessageDigestImpl

    public abstract class MessageDigest

extends Object

The `MessageDigest` class is the base class for hashing algorithms. Implementations of `MessageDigest` algorithms must extend this class and implement all the abstract methods.

A tear or card reset event resets a `MessageDigest` object to the initial state (state upon construction).

Even if a transaction is in progress, update of intermediate result state in the implementation instance shall not participate in the transaction.

Field Summary
`static byte` | `ALG_MD5` Message Digest algorithm MD5.
`static byte` | `ALG_RIPEMD160` Message Digest algorithm RIPE MD-160.
`static byte` | `ALG_SHA` Message Digest algorithm SHA.

Constructor Summary
`protected` | `MessageDigest()` Protected Constructor

Method Summary
`abstract short` | `doFinal(byte[] inBuff, short inOffset, short inLength, byte[] outBuff, short outOffset)` Generates a hash of all/last input data.
`abstract byte` | `getAlgorithm()` Gets the Message digest algorithm.
`static MessageDigest` | `getInstance(byte algorithm, boolean externalAccess)` Creates a `MessageDigest` object instance of the selected algorithm.
`abstract byte` | `getLength()` Returns the byte length of the hash.
`abstract void` | `reset()` Resets the `MessageDigest` object to the initial state for further use.
`abstract void` | `update(byte[] inBuff, short inOffset, short inLength)` Accumulates a hash of the input data.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ALG_SHA

    public static final byte ALG_SHA

  Message Digest algorithm SHA.

  See Also:
    Constant Field Values

### ALG_MD5

    public static final byte ALG_MD5

  Message Digest algorithm MD5.

  See Also:
    Constant Field Values

### ALG_RIPEMD160

    public static final byte ALG_RIPEMD160

  Message Digest algorithm RIPE MD-160.

  See Also:
    Constant Field Values

Constructor Detail

### MessageDigest

    protected MessageDigest()

  Protected Constructor

Method Detail

### getInstance

    public static final MessageDigest getInstance(byte algorithm,
                                                  boolean externalAccess)
                                           throws CryptoException

  Creates a `MessageDigest` object instance of the selected algorithm.

  Parameters:
    `algorithm` - the desired message digest algorithm. Valid codes listed in ALG_ .. constants above, for example, `ALG_SHA`.
    `externalAccess` - `true` indicates that the instance will be shared among multiple applet instances and that the `MessageDigest` instance will also be accessed (via a `Shareable`. interface) when the owner of the `MessageDigest` instance is not the currently selected applet. If `true` the implementation must not allocate CLEAR_ON_DESELECT transient space for internal data.
  Returns:
    the `MessageDigest` object instance of the requested algorithm
  Throws:
    `CryptoException` - with the following reason codes:
    - `CryptoException.NO_SUCH_ALGORITHM` if the requested algorithm or shared access mode is not supported.

### getAlgorithm

    public abstract byte getAlgorithm()

  Gets the Message digest algorithm.

  Returns:
    the algorithm code defined above

### getLength

    public abstract byte getLength()

  Returns the byte length of the hash.

  Returns:
    hash length

### doFinal

    public abstract short doFinal(byte[] inBuff,
                                  short inOffset,
                                  short inLength,
                                  byte[] outBuff,
                                  short outOffset)

  Generates a hash of all/last input data. Completes and returns the hash computation after performing final operations such as padding. The `MessageDigest` object is reset to the initial state after this call is made.

  The input and output buffer data may overlap.

  Parameters:
    `inBuff` - the input buffer of data to be hashed
    `inOffset` - the offset into the input buffer at which to begin hash generation
    `inLength` - the byte length to hash
    `outBuff` - the output buffer, may be the same as the input buffer
    `outOffset` - the offset into the output buffer where the resulting hash value begins
  Returns:
    number of bytes of hash output in `outBuff`

### update

    public abstract void update(byte[] inBuff,
                                short inOffset,
                                short inLength)

  Accumulates a hash of the input data. This method requires temporary storage of intermediate results. In addition, if the input data length is not block aligned (multiple of block size) then additional internal storage may be allocated at this time to store a partial input data block. This may result in additional resource consumption and/or slow performance. This method should only be used if all the input data required for the hash is not available in one byte array. If all of the input data required for the hash is located in a single byte array, use of the `doFinal()` method is recommended. The `doFinal()` method must be called to complete processing of input data accumulated by one or more calls to the `update()` method.

  Note:

  - If `inLength` is 0 this method does nothing.

  Parameters:
    `inBuff` - the input buffer of data to be hashed
    `inOffset` - the offset into the input buffer at which to begin hash generation
    `inLength` - the byte length to hash See also: `doFinal(byte[], short, short, byte[], short)`

### reset

    public abstract void reset()

  Resets the `MessageDigest` object to the initial state for further use.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD